Bug 1114240 - Bad pointer manipulation on 64 bit architectures
Summary: Bad pointer manipulation on 64 bit architectures
Status: CLOSED ERRATA
Alias: None
Product: Fedora EPEL
Classification: Fedora
Component: R
Version: epel7
Hardware: ppc64
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Tom "spot" Callaway
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: ZedoraTracker PPCTracker
TreeView+ depends on / blocked
 
Reported: 2014-06-29 03:57 UTC by Mattias Ellert
Modified: 2014-09-09 22:23 UTC (History)
4 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2014-09-06 20:30:26 UTC


Attachments (Terms of Use)
Patch correcting the pointer type (397 bytes, patch)
2014-06-29 03:57 UTC, Mattias Ellert
no flags Details | Diff

Description Mattias Ellert 2014-06-29 03:57:12 UTC
Created attachment 913144 [details]
Patch correcting the pointer type

Description of problem:

Casts a pointer to uintptr_t to a pointer to unsigned int.

On a 32 bit architecture this is OK since sizeof(uintptr_t) == sizeof(unsigned int).

On a 64 bit LE architecture (like x86_64) this is not quite right. The unsigned int will be the lower 32 bits of the uintptr_t. As long as the value is less than 2^32 it will work - which is usually the case here.

On a 64 bit BE architecture (like ppc64) this is very wrong. The unsigned int will be the high 32 bits of the uintptr_t, i.e. the value is divided by 2^32.

Version-Release number of selected component (if applicable):

R-core-3.1.0-5.el7.ppc64.rpm
R-core-3.1.0-5.el6.ppc64.rpm

Patch attached.

Additional info:

I found this issue when I tried to figure out why the %check fails on the build of R-qtl. However, I have no access to a ppc64 RHEL installation so I can not be sure this is the reason for the failure. I would have to do a chained scratch build in koji which is not possible. The current R-qtl specfile puts the check inside %ifnarch ppc64.

Comment 1 Jakub Čajka 2014-07-04 09:57:41 UTC
I have made test rebuild of R-qtl using patched R on ppc64. %check passes without any problems.

Comment 2 Tom "spot" Callaway 2014-07-08 19:47:44 UTC
Upstream R is merging this change into 3.1.1. We'll pick it up with that drop later this week.

Comment 3 Fedora Update System 2014-07-17 14:50:43 UTC
rkward-0.6.1-9.fc20,rpy-2.3.10-2.fc20,R-3.1.1-1.fc20,R-qtl-1.32.10-4.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/rkward-0.6.1-9.fc20,rpy-2.3.10-2.fc20,R-3.1.1-1.fc20,R-qtl-1.32.10-4.fc20

Comment 4 Fedora Update System 2014-07-17 14:50:56 UTC
rkward-0.6.1-9.fc19,rpy-2.3.10-2.fc19,R-3.1.1-1.fc19,R-qtl-1.32.10-4.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/rkward-0.6.1-9.fc19,rpy-2.3.10-2.fc19,R-3.1.1-1.fc19,R-qtl-1.32.10-4.fc19

Comment 5 Fedora Update System 2014-07-17 14:51:07 UTC
R-3.1.1-1.el5,R-qtl-1.32.10-4.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/R-3.1.1-1.el5,R-qtl-1.32.10-4.el5

Comment 6 Fedora Update System 2014-07-17 14:51:18 UTC
R-3.1.1-1.el6,R-qtl-1.32.10-4.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/R-3.1.1-1.el6,R-qtl-1.32.10-4.el6

Comment 7 Fedora Update System 2014-07-19 06:06:51 UTC
Package rkward-0.6.1-9.fc19, rpy-2.3.10-2.fc19, R-3.1.1-1.fc19, R-qtl-1.32.10-4.fc19:
* should fix your issue,
* was pushed to the Fedora 19 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing rkward-0.6.1-9.fc19 rpy-2.3.10-2.fc19 R-3.1.1-1.fc19 R-qtl-1.32.10-4.fc19'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2014-8532/rkward-0.6.1-9.fc19,rpy-2.3.10-2.fc19,R-3.1.1-1.fc19,R-qtl-1.32.10-4.fc19
then log in and leave karma (feedback).

Comment 8 Fedora Update System 2014-09-06 20:30:26 UTC
R-3.1.1-1.el5, R-qtl-1.32.10-4.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 9 Fedora Update System 2014-09-06 20:31:07 UTC
R-3.1.1-1.el6, R-qtl-1.32.10-4.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 10 Fedora Update System 2014-09-09 22:08:26 UTC
rkward-0.6.1-9.fc19, rpy-2.3.10-2.fc19, R-3.1.1-1.fc19, R-qtl-1.32.10-4.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 11 Fedora Update System 2014-09-09 22:23:35 UTC
rkward-0.6.1-9.fc20, rpy-2.3.10-2.fc20, R-3.1.1-1.fc20, R-qtl-1.32.10-4.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.